/***********************************************************************

  ColorBox2: utils.cpp
    (c) 2004 by Martin Decky
  
  Distributed under the terms of Lesser General Public Licence, see
  COPYING.

  0.3			10th August 2004	conversion from C to C++

***********************************************************************/


#include <cb2/utils.h>


using namespace CB2;


size_t Class::Sizeof() const {
	return sizeof(this);
}


Exception::Exception() {
	except = "";
}


Exception::Exception(const String what) {
	except = what;
}


Exception::Exception(const String what, const int line) {
	except = what + String(" (line ") + String(line) + String(")");
}
			

String Exception::What() const {
	return except;
}


ExceptionConversion::ExceptionConversion()
	: Exception() {
}


ExceptionConversion::ExceptionConversion(const String what)
	: Exception(what) {
}


ExceptionConversion::ExceptionConversion(const String what, const int line)
	: Exception(what, line) {
}


ExceptionMemory::ExceptionMemory()
	: Exception() {
}


ExceptionMemory::ExceptionMemory(const String what)
	: Exception(what) {
}


ExceptionMemory::ExceptionMemory(const String what, const int line)
	: Exception(what, line) {
}


ExceptionAssert::ExceptionAssert()
	: Exception() {
}


ExceptionAssert::ExceptionAssert(const String what)
	: Exception(what) {
}


ExceptionAssert::ExceptionAssert(const String what, const int line)
	: Exception(what, line) {
}


ExceptionNotFound::ExceptionNotFound()
	: Exception() {
}


ExceptionNotFound::ExceptionNotFound(const String what)
	: Exception(what) {
}


ExceptionNotFound::ExceptionNotFound(const String what, const int line)
	: Exception(what, line) {
}


template class PString< char>;          /**< Explicit template instantiation */
template class PStringTokenizer< char>; /**< Explicit template instantiation */


