/***********************************************************************

  ColorBox2: Application.cpp
    (c) 2004 by Martin Decky
  
  Distributed under the terms of Lesser General Public Licence, see
  COPYING.

  0.2			20th June 2003		basic structure
  0.3			20th August 2004	rewrite

***********************************************************************/


#include <iostream>
#include <cb2/Application.h>


using namespace CB2;
using namespace std;


Application::Application() {
	templ = NULL;
	mime = "text/html";
	member = NULL;
}


Application::~Application() {
	if (templ) {
		cout << mime << endl;
		
		if (member)
			delete member;
		else
			templ->Subst(anchor, "");
			
		cout << templ->Render();
		delete templ;
	} else {
		cout << "text/html" << endl;
		cout << "<html>" << endl
			<< "<head>" << endl
			<< " <title>Default ColorBox2 Application</title>" << endl
			<< "</head>" << endl
			<< "<body>" << endl
			<< "<h1>Default ColorBox2 Application</h1>" << endl
			<< "<p>Default CB2::Application class used.</p>" << endl
			<< "</body>" << endl
			<< "</html>" << endl;
	}
}


Template * Application::Register(Widget * child, String & anc) {
	if (child == NULL)
		return NULL;
	
	CB2_ASSERT(member == NULL, "CB2::Application can contain just one container");
	
	member = child;
	anc = anchor;
	return templ;
}


void Application::SetTemplate(Template * temp, const String & anc) {
	templ = temp;
	anchor = anc;
}


void Application::SetMimeType(const String & mtype) {
	mime = mtype;
}


void Application::AppEntry(Application & app, int argc, char * argv[]) {
	// FIXME TODO:
	//  - parse cmdline
	//  - parsa input
}


void Application::AppError(const String & error, const String & desc) {
	cout << "text/html" << endl
		<< "<html>" << endl
		<< "<head>" << endl
		<< " <title>" << error.HTML() << "</title>" << endl
		<< "</head>" << endl
		<< "<body>" << endl
		<< "<h1>" << error.HTML() << "</h1>" << endl
		<< "<p>";
	
	if (desc == "")
		cout << "See debug output";
	else
		cout << desc;
		
	cout << "</p>" << endl
		<< "</body>" << endl
		<< "</html>" << endl;
}
