/***********************************************************************

  ColorBox2: Application.h
    (c) 2004 by Martin Decky
  
  Distributed under the terms of Lesser General Public Licence, see
  COPYING.

  0.2			20th June 2003		basic structure
  0.3			20th August 2004	rewrite

***********************************************************************/


#ifndef __CB2__APPLICATION_H__
#define __CB2__APPLICATION_H__


#include <cb2/utils.h>
#include <cb2/Template.h>
#include <cb2/Widgets.h>


#define CB2_IMPLEMENT_APP(AppType) \
	int main(int argc, char * argv[]) { \
		try { \
			AppType app; \
			CB2::Application::AppEntry(app, argc, argv); \
		} catch (Exception & e) { \
			CB2::Application::AppError("Application exception", e.What()); \
		} catch (...) { \
			CB2::Application::AppError("Fatal application exception"); \
		} \
		\
		return 0; \
	}


namespace CB2 {

	
	class Application : public Class {
		public:
			Application();
			~Application();
			
			void SetTemplate(Template * temp, const String & anc);
			void SetMimeType(const String & mtype);
			
			Template * Register(Widget * child, String & anc);
			
			static void AppEntry(Application & app, int argc, char * argv[]);
			static void AppError(const String & error, const String & desc = "");
			
		private:
			Widget * member;
			Template * templ;
			String anchor;
			String mime;
	};
	
	
}


#endif
