/***********************************************************************

  ColorBox2: Containers.cpp
    (c) 2004 by Martin Decky
  
  Distributed under the terms of Lesser General Public Licence, see
  COPYING.

  0.3			20th August 2004	initial

***********************************************************************/


#include <cb2/Containers.h>


using namespace CB2;


ContainerBin::ContainerBin(Container & parent)
	: Container(parent) {
	member = NULL;
}


ContainerBin::ContainerBin(Application & parent)
	: Container(parent) {
	member = NULL;
}


ContainerBin::~ContainerBin() {
	if (member) {
		delete member;
		Data(mtempl->Render());
		delete mtempl;
	} else
		Data("");
}


Template * ContainerBin::Add(Widget * child, String & anchor) {
	if (child == NULL)
		return NULL;
	
	CB2_ASSERT(member == NULL, "CB2::ContainerBin should contain just one child");
	
	member = child;
	mtempl = new Template("&&BIN");
	anchor = "BIN";
	return mtempl;
}
