/***********************************************************************

  ColorBox2: Template.cpp
    (c) 2004 by Martin Decky
  
  Distributed under the terms of Lesser General Public Licence, see
  COPYING.

  0.2			20th June 2003		basic structure
  0.3			20th August 2004	rewrite

***********************************************************************/


#include "Template.h"


using namespace CB2;


Template::Template(const String & value) {
	macro = value;
}


String::size_type Template::Subst(const String & anchor, const String & value) {
	return macro.Subst(String("&&") + anchor, value);
}


String Template::Render() {
	/* Work on a copy of template */
	String temp = macro;

	/* Check for any &&anchor left */
	String::size_type pos;
	while (temp.Pos("&&", pos)) {
		char next = 0;
		
		try {
			next = temp[pos + 2];
		} catch (ExceptionRange< String::size_type>) {
			/* Out of range, throw different kind
			   of exception */
			throw ExceptionAssert("Misformed anchor at the end of the template");
		}
		
		if (next != '&') /* This anchor is not an escaped &  */
			throw ExceptionAssert("Unsubstituted anchor in template");
	}

	/* Replace all &&&s with & */
	temp.Subst("&&&", "&");
	
	return temp;
}


Template::Template() {
	CB2_ASSERT(false, "Template cannot be empty");
}
