/***********************************************************************

  ColorBox2: Widgets.cpp
    (c) 2004 by Martin Decky
  
  Distributed under the terms of Lesser General Public Licence, see
  COPYING.

  0.3			20th August 2004	initial

***********************************************************************/


#include <cb2/Widgets.h>
#include <cb2/Application.h>


using namespace CB2;


Widget::Widget(Container & parent) {
	ptempl = parent.Add(this, panchor);
	filled = false;
}


Widget::Widget(Application & parent) {
	ptempl = parent.Register(this, panchor);
	filled = false;
}


void Widget::Data(const String & data) {
	filled = true;
	if (ptempl)
		ptempl->Subst(panchor, data);
}


Widget::~Widget() {
	CB2_ASSERT(filled, "Widget didn't supply its data to parent");
}


Widget::Widget(const Widget & prev) {
	CB2_ASSERT(false, "Widget cannot use copy constructor");
}


void Widget::operator=(const Widget & prev) {
	CB2_ASSERT(false, "Widget cannot use assignment operator");
}


Container::Container(Container & parent)
	: Widget(parent) {
}


Container::Container(Application & parent)
	: Widget(parent) {
}

