/***********************************************************************

  ColorBox2: Widgets.h
    (c) 2004 by Martin Decky
  
  Distributed under the terms of Lesser General Public Licence, see
  COPYING.

  0.3			20th August 2004	initial

***********************************************************************/


#ifndef __CB2__WIDGETS_H__
#define __CB2__WIDGETS_H__


#include <cb2/utils.h>
#include <cb2/Template.h>


namespace CB2 {
	
	class Container;   /**< Forward declaration */
	class Application; /**< Forward declaration */
	
	class Widget : public Class {
		public:
			Widget(Container & parent);
			Widget(Application & parent);
			virtual ~Widget();
			
		protected:
			void Data(const String & data);
			
		private:
			Widget(const Widget & prev);
			void operator=(const Widget & prev);
			
			Template * ptempl;
			String panchor;
			bool filled;
	};
	
	
	class Container : public Widget {
		public:
			Container(Container & parent);
			Container(Application & parent);
			
			virtual Template * Add(Widget * child, String & anchor) = 0;
	};
	
	
}


#endif
